#ifndef ParameterDelegate_H
#define ParameterDelegate_H

#include <QtGui>
//TODO Keep only the usefull includes

#include <Controller.hpp>

namespace hatptester{

class ParameterDelegate : public QItemDelegate{ //To provide a new type of cell which diplay all possible value for a parameter
	Q_OBJECT

private:
	HATPController& controller;
	
signals:
	void requestIsReady() const;
	void modelUpdated() const;

public:
	ParameterDelegate(QObject* parent=0):QItemDelegate(parent), controller(HATPController::getInstance()){}

	QWidget* createEditor(QWidget* parent, const QStyleOptionViewItem& option, const QModelIndex& index) const{
		if(index.column()==1){ //If the cell is about a parameter's value then create a ComboBox
			QComboBox* possibleValues=new QComboBox(parent);
	
			const HATPState::EntitiesMap& entities=controller.getEntities();
			for(HATPState::EntitiesMap::const_iterator it=entities.begin(); it!=entities.end(); ++it){
				if(it->second.getType()==index.data(Qt::UserRole).toString().toStdString()){
					possibleValues->addItem(it->first.c_str());
				}
			}
		
			return possibleValues;
		}
		//Else don't create an editor (the cell is about a parameter's name)
		return NULL;
	}

	void setEditorData(QWidget* editor, const QModelIndex& index) const{}
	
	void setModelData(QWidget* editor, QAbstractItemModel* model, const QModelIndex& index) const{
		QComboBox* possibleValues = static_cast<QComboBox*>(editor);
		model->setData(index, possibleValues->currentText(), Qt::EditRole);
		emit modelUpdated();
		if(controller.isReadyCurrentTask()){
			emit requestIsReady();
		}
	}

	void updateEditorGeometry(QWidget* editor, const QStyleOptionViewItem& option, const QModelIndex& index) const{
		editor->setGeometry(option.rect);
	}
};

}; //namespace

#endif //ParameterDelegate_H
